'From Objectworks(r)\Smalltalk, Release 4 of 25 October 1990 on 10 March 1993 at 3:07:28 am'!



!ChangeSet class methodsFor: '(ClassTalk) fileIn/Out'!

superclassOrder: classes 
	"Arrange the classes in the collection, classes, in superclass order so the classes can be properly filed in.  Class A must come before class B if A is a superclass of B, or if B is A's metaclass."
	"This has been completed in order to work for multiple inheritance."
	"For ObjVlisp classes (and only for them, see above), we need a metaclass to be arranged before a class."
	| order left |
	left _ IdentitySet new.
	left addAll: classes.
	order _ OrderedCollection new.
	[left isEmpty] whileFalse:
		[left do: [:c | ((((left includes: c superclass) or: [(c isKindOf: Metaclass) and: [left includes: c soleInstance]])
				or: [c hasMultipleSuperclasses and:
					[(c superclasses collect: [:sc | left includes: sc]) includes: true]])
					or: [c isObjVlispClass and: [left includes: c class]])
						ifFalse: [order addLast: c. left remove: c]]].
	^order! !