'From Objectworks(r)\Smalltalk, Release 4 of 25 October 1990 on 10 March 1993 at 2:28:12 am'!



!Behavior methodsFor: '(ClassTalk) Multiple Inheritance'!

accumulateInstVarNames: names traversedClasses: classSet 

	^self accumulateInstVarNames: names.

"
	self superclasses do: [:each | each isObjVlispClass
			ifTrue: [each accumulateInstVarNames: names traversedClasses: classSet]
			ifFalse: [each accumulateInstVarNames: names]].
	(classSet includes: self)
		ifFalse: 
			[names addAll: self instVarNames.
			classSet add: self]
"!

addSubclass: aSubclass 
	"Pour permettre a des MIClass d'heriter de classes a Heritage Simple je dois ecraser le addSubclass
standard de Behavior 2.5"
	
	(aSubclass superclasses includes: self)
		ifTrue: [subclasses == nil
				ifTrue: [subclasses _ Set with: aSubclass]
				ifFalse: [subclasses add: aSubclass]]
		ifFalse: [self halt: aSubclass name , ' is not my subclass']

"
Voila son ancienne definition
	aSubclass superclass = self
		ifTrue: [subclasses == nil
					ifTrue:	[subclasses _ Set with: aSubclass]
					ifFalse:	[subclasses add: aSubclass]]
		ifFalse: [self error: aSubclass name , ' is not my subclass']
"!

allSuperclassesInto: orderedCollection
	"Add all my superclasses to orderedCollection if not already there.
	  Use breadth-first order."
	| mysupers |
	mysupers _ self superclasses.
	mysupers do: [:each | each allSuperclassesInto: orderedCollection].
	mysupers reverseDo: 
		[:each | (orderedCollection includes: each) ifFalse: [orderedCollection addFirst: each]]!

hasMultipleSuperclasses
	^false!

superclasses
	"Attention je detruis la methode dinstance de meme nom de Behavior en 2.4"
	superclass isNil ifTrue: [^#()].
	^Array with: superclass! !