'From Objectworks(r)\Smalltalk, Release 4 of 25 October 1990 on 10 March 1993 at 5:47:38 am'!



!Object methodsFor: '(ClassTalk) initialization'!

initialize: initArray
	self initialize: initArray with: self class allInstVarNames!

initialize: initArray with: ivNames 
	"Pour une initialisation uniforme et generique a la ObjVlisp"

	| i max context  aCompiler iv ivValue ivValueC trace |
	trace _ false.
	aCompiler _ Compiler new.
	initArray isEmpty
		ifFalse: 
			[i _ 1.
			Version = '2.5' 
				ifTrue: [context _  thisContext sender]
			 	ifFalse: [context _ thisContext sender sender].
			max _ initArray size.
			trace ifTrue: [Transcript cr; show: 'Trace du initialize'].
			[i < max]
				whileTrue: 
					[iv _ initArray at: i.
					ivValue _ initArray at: i + 1.
					trace ifTrue: [Transcript cr; show: iv printString; show: '  ' , ivValue printString].
					(ivValue class = Array and: [(ivValue at: 1) = #quote])
						ifTrue: [ivValueC _ ivValue at:2]
						ifFalse: [ivValueC _ aCompiler
										evaluate: ivValue printString
										in: context
										receiver: context receiver
										"to: context receiver 2.4"
										notifying: []
										ifFail: [self halt: 'Compiler has failed in Object.initialize:']].
					"self halt: 'Trace: Object.initialize:'."
					trace ifTrue: [Transcript tab; show: '--->  ' , ivValueC printString].
					self instVarAt: (ivNames indexOf: iv ifAbsent: [self ivError: iv])
						put: ivValueC.
					"(Compiler evaluate: ivValue printString for: thisContext logged: true)."
					trace ifTrue: [Transcript cr; show: '-------------'; cr; cr].
					i _ i + 2]]!

ivError: ivName 
	self error: 'Object.initialize: ' , ivName printString , '   N''est pas une variable d''instance de ' , self class name printString! !