'From Objectworks(r)\Smalltalk, Release 4 of 25 October 1990 on 10 March 1993 at 3:19:33 am'!



!LauncherView class methodsFor: 'class initialization'!

initializeLauncherMenu
	"Initialize the system launcher menu"
	"LauncherView initializeLauncherMenu."

	| keys subMenu defaultFontKey |
	defaultFontKey := #bold.
	keys := #('Browsers' 'Utilities' 'Changes' 'Special' 'Quit').
	LauncherMenu := PopUpMenu
			labelList: (Array with: keys)
			values: (Array new: keys size).
	LauncherMenu fontKey: defaultFontKey.

	keys := #('system' 'class' 'senders' 'implementors' 'objVlisp').
	subMenu := PopUpMenu
			labelList: (Array with: keys)
			values: (Array new: keys size).
	subMenu fontKey: defaultFontKey.
	subMenu valueAt: 1 put: [BrowserView openOn: SystemOrganization].
	subMenu valueAt: 2 put: [Browser newPickClass].
	subMenu valueAt: 3 put: [Smalltalk promptThenBrowseCalls].
	subMenu valueAt: 4 put: [Smalltalk promptThenBrowseImplementors].
	subMenu valueAt: 5 put: [  NewClassTalkBrowserView openOn: ObjVlispOrganization].
	LauncherMenu valueAt: 1 put: subMenu.

	keys := #('file list' 'file editor' 'system workspace' 'transcript' 'workspace').
	subMenu := PopUpMenu
			labelList: (Array with: keys)
			values: (Array new: keys size).
	subMenu fontKey: defaultFontKey.
	subMenu valueAt: 1 put: [FileBrowser open].
	subMenu valueAt: 2 put: [FileBrowser openPrompted].
	subMenu valueAt: 3 put: [StringHolderView openSystemWorkspace].
	subMenu valueAt: 4 put: [TextCollectorView open: Transcript label: 'System Transcript'].
	subMenu valueAt: 5 put: [StringHolderView open].
	LauncherMenu valueAt: 2 put: subMenu.

	keys := #('open change list' 'inspect ChangeSet' 'file out ChangeSet' 'empty ChangeSet').
	subMenu := PopUpMenu
			labelList: (Array with: keys)
			values: (Array new: keys size).
	subMenu fontKey: defaultFontKey.
	subMenu valueAt: 1 put: [ChangeListView open].
	subMenu valueAt: 2 put: [Smalltalk changes inspect].
	subMenu valueAt: 3 put: [Filename fileOutChanges].
	subMenu valueAt: 4 put: 
		[(DialogView confirm: 'Really empty the current change set?') 
			ifTrue: [Smalltalk noChanges]].
	LauncherMenu valueAt: 3 put: subMenu.

	keys := #('refresh windows' 'collect garbage' 'open project' 'exit project' 'save').
	subMenu := PopUpMenu
			labelList: (Array with: keys)
			values: (Array new: keys size).
	subMenu fontKey: defaultFontKey.
	subMenu valueAt: 1 put: [ScheduledControllers restore].
	subMenu valueAt: 2 put: [ObjectMemory verboseCompactingGC].
	subMenu valueAt: 3 put: [Project openViewOn: Project new].
	subMenu valueAt: 4 put: [Project current exit].
	subMenu valueAt: 5 put: [Smalltalk saveDialog].
	LauncherMenu valueAt: 4 put: subMenu.

	LauncherMenu valueAt: 5 put: [Smalltalk quitDialog].! !