'From Objectworks(r)\Smalltalk, Release 4 of 25 October 1990 on 10 March 1993 at 5:50:58 am'!



!NameScope class methodsFor: '(ClassTalk) instance creation'!

forClass: aClass outerScope: aScope 
	"MODIFIED FOR MULTIPLEINHERITANCE.
	Return a NameScope (the innermost of a chain) 
	that reflects the naming environment of aClass. 
	aScope is taken as the outer scope (beyond Object.) 
	This algorithm is not very efficient, but it works."

	| scope builder outer static pools |
	scope _ LocalScope new.
	builder _ ProgramNodeBuilder new.
	outer _ aScope.
	scope instanceVariables: (aClass allInstVarNames collect: [:vName | builder newVariableName: vName])
		startingAt: 0.
	aClass withAllSuperclasses
		reverseDo: 
			[:class | 
			"The following patch is required because Metaclasses 
			don't report their instance's sharedPools 
			(but they do report the classPool -- why??)."
			pools _ class isMeta
						ifTrue: [class soleInstance sharedPools]
						ifFalse: [class sharedPools].
			pools do: 
				[:pool | 
				static _ StaticScope variables: pool.
				static outerScope: outer.
				outer _ static].
			static _ StaticScope classVariables: class.
			static outerScope: outer.
			outer _ static].
	scope outerScope: static.
	^scope! !