'From Objectworks(r)\Smalltalk, Release 4 of 25 October 1990 on 10 March 1993 at 2:27:34 am'!



!Behavior methodsFor: '(ClassTalk) creation'!

allocate: initArray 
	"Il existe deux allocateurs standard en Smalltalk"
	
	self isVariable
		ifFalse: [^self basicNew]
		ifTrue: [^self allocateVariable: initArray]!

allocateVariable: initArray 
	"Il existe deux allocateurs standard en Smalltalk"

	| sizeValue copie |
	(initArray includes: #size)
		ifTrue: 
			[sizeValue _ initArray at: (initArray indexOf: #size)
							+ 1.
			copie _ initArray copyClassTalk: (initArray indexOf: #size).
			initArray become: copie]
		ifFalse: [sizeValue _ self defaultSize].
	^self basicNew: sizeValue!

create
	^self create: #()!

create: initArray 
	"La creation s'exprime comme la composition d'un allocateur et d'un  
	initialisateur"

	^(self allocate: initArray) initialize: initArray

"
Pour tester la chose  
Point create nil@nil
Point basicNew initialize: #(x 2 y 3). 
Point create: #(x 2 y 3).  
Point create: #().  
Point create: #(y 4 x 2).  
Point create: #(y 4 x y).  
Point create: #(y 5).  
Point create: #( y (2 *  3) x (7 * 6)) .
Point create: #( y (quote (2 *  3))  x (quote x)) .
Array create: #(size 5) (nil nil nil nil nil ). 
Array create: #()  (nil nil nil )
(OrderedCollection create: #(size 7)) setIndices basicInspect
(OrderedCollection create: #(size 10 firstIndex (self basicSize // 2 + 1) lastIndex (firstIndex - 1))) basicInspect
"!

defaultSize
	^0! !